//
//  FriendsViewController.swift
//  VK Tosters
//
//  Created programmist_np on 21/01/2020.
//  Copyright © 2020 programmist_np. All rights reserved.
//
//  Template generated by Juanpe Catalán @JuanpeCMiOS
//

import UIKit
import UIKit.UIGestureRecognizerSubclass
import MaterialComponents
import Material
import AsyncDisplayKit

class FriendsViewController: UIBaseTableNodeController, UIBaseViewControllerProtocol, UIBaseTableViewControllerProtocol, FriendsViewProtocol {
    var presenter: FriendsPresenterProtocol?
    var userId: Int?
    var searchController: VKSearchBar = VKSearchBar(frame: CGRect(origin: .zero, size: CGSize(width: Screen.bounds.width, height: 52)))
    private var friendViewModel = FriendViewModel.init(cell: [], footerTitle: nil)
    let activityIndicator = MDCActivityIndicator()
    private lazy var footerView = FooterView()
    
    convenience init(id: Int) {
        self.init()
        userId = id
    }

    override func viewDidLoad() {
        super.viewDidLoad()
        prepareSpace()
        prepareToolbar(fonts: [GoogleSansFont.bold(with: 21), GoogleSansFont.regular(with: 13)])
        setupToolbar(title: "Друзья", subtitle: "", leftViews: nil, rightViews: nil)
        // prepareTable()
        setupTable()
        initialComponent()
        FriendsRouter.createModule(viewController: self)
        // MARK: Timely var
        presenter?.start(request: .getFriend())
    }
    
    func setupToolbar(title: String, subtitle: String, leftViews: [UIView]?, rightViews: [UIView]?) {
        toolbar.title = title
        toolbar.detail = subtitle
        if let leftViews = leftViews {
            toolbar.leftViews = leftViews
        }
        if let rightViews = rightViews {
            toolbar.rightViews = rightViews
        }
    }
    
    func initialComponent() {
        // Progress indicator
        activityIndicator.sizeToFit()
        view.addSubview(activityIndicator)
        activityIndicator.autoCenterInSuperview()
        activityIndicator.radius = 15
        activityIndicator.strokeWidth = 3
        activityIndicator.indicatorMode = .indeterminate
        activityIndicator.cycleColors = [.extendedBlue]
        activityIndicator.isHidden = true
    }
    
    func setupTable() {
        mainTableNode.view.prepareBackground()
        mainTableNode.view.keyboardDismissMode = .onDrag
        mainTableNode.delegate = self
        mainTableNode.dataSource = self
        mainTableNode.view.tableFooterView = footerView
        mainTableNode.view.tableHeaderView = searchController
        searchController.setup(placeholder: "Поиск")
        refreshControl.addTarget(self, action: #selector(refreshTable(_:)), for: UIControl.Event.valueChanged)
        activityIndicator.startAnimating()
    }
    
    func initialFooter() {
        
    }
    
    func displayData(viewModel: FriendModel.ViewModel.ViewModelData) {
        switch viewModel {
        case .displayFriend(friendViewModel: let friendViewModel):
            self.friendViewModel = friendViewModel
            mainTableNode.reloadData()
            refreshControl.endRefreshing()
            let friendsCount = friendViewModel.cell.count > 0 ? "\(friendViewModel.cell.count) \(getStringByDeclension(number: friendViewModel.cell.count, arrayWords: Localization.instance.friendsCount))" : "Нет друзей"
            footerView.setTitle(friendsCount)
        case .displayFooterLoader:
            footerView.setTitle("")
            footerView.showLoader()
        case .displayFooterError(message: let message):
            toolbar.title = "Ошибка загрузки"
            footerView.setTitle(message)
            mainTableNode.reloadData()
            refreshControl.endRefreshing()
        }
    }
    
    @objc func refreshTable(_ sender: Any?) {
        presenter?.start(request: .getFriend())
    }
    
    func showErrorConnection() {
        mainTableNode.reloadData()
        mainTableNode.toggleNoMessagesNote(on: true, with: "Проблема с подключением", at: "no_connection")
    }
}
extension FriendsViewController: FriendCellProtocol {
    func onTapToChat(_ button: IconButton, peerId: Int) {
        Vibration.selection.vibrate()
        self.presenter?.onTapToChat(peerId: peerId)
    }
}
extension FriendsViewController: ASTableDelegate, ASTableDataSource {
    func tableNode(_ tableNode: ASTableNode, numberOfRowsInSection section: Int) -> Int {
        if section == 0 {
            return friendViewModel.cell.count < 5 ? friendViewModel.cell.count : 5
        } else {
            return friendViewModel.cell.count
        }
    }
    
    func numberOfSections(in tableNode: ASTableNode) -> Int {
        return 2
    }
    
    func tableNode(_ tableNode: ASTableNode, nodeBlockForRowAt indexPath: IndexPath) -> ASCellNodeBlock {
        var node: ASCellNode
        if indexPath.section == 0 {
            node = FriendCellNode(by: friendViewModel.cell[indexPath.row])
        } else {
            node = FriendCellNode(by: friendViewModel.cell[indexPath.row])
        }
        node.selectionStyle = .none
        (node as! FriendCellNode).delegate = self
        return { () -> ASCellNode in
            return node
        }
    }
    
    func tableView(_ tableView: UITableView, viewForHeaderInSection section: Int) -> UIView? {
        guard friendViewModel.cell.count > 0 else { return nil }
        let returnedView = UIView(frame: CGRect(x: 0, y: 0, width: UIScreen.main.bounds.width, height: 38))
        let dividerView = UIView(frame: CGRect(x: 0, y: 0, width: UIScreen.main.bounds.width, height: 0.5))
        returnedView.backgroundColor = .adaptableWhite
        dividerView.backgroundColor = UIColor.adaptableGrayVK.withAlphaComponent(0.2)
        let label = UILabel()
        label.textColor = .adaptableBlack
        label.font = GoogleSansFont.bold(with: 17)
        
        returnedView.addSubview(dividerView)
        dividerView.autoPinEdge(.top, to: .top, of: returnedView, withOffset: 0.5)
        dividerView.autoPinEdge(.trailing, to: .trailing, of: returnedView, withOffset: -12)
        dividerView.autoPinEdge(.leading, to: .leading, of: returnedView, withOffset: 12)
        dividerView.autoSetDimension(.height, toSize: 0.5)
        returnedView.addSubview(label)
        label.autoPinEdge(.top, to: .top, of: returnedView, withOffset: 13)
        label.autoPinEdge(.bottom, to: .bottom, of: returnedView, withOffset: -9)
        label.autoPinEdge(.leading, to: .leading, of: returnedView, withOffset: 12)
        label.autoPinEdge(.trailing, to: .trailing, of: returnedView, withOffset: -12)
        label.autoSetDimension(.height, toSize: 22)
        switch section {
        case 0:
            label.text = "Важные"
            
        case 1:
            label.text = "Все друзья"
            
        default: label.text = ""
        }
        return returnedView
    }
    
    func tableView(_ tableView: UITableView, heightForHeaderInSection section: Int) -> CGFloat {
        guard friendViewModel.cell.count > 0 else { return 0 }
        return 44
    }
    
    func tableNode(_ tableNode: ASTableNode, didSelectRowAt indexPath: IndexPath) {
        guard let presenter = presenter else { return }
        if indexPath.section == 0 {
            let friend = friendViewModel.cell[indexPath.row]
            presenter.onTapFriend(userId: friend.id!)
        } else {
            let friend = friendViewModel.cell[indexPath.row]
            presenter.onTapFriend(userId: friend.id!)
        }
    }
    
    func tableNode(_ tableNode: ASTableNode, constrainedSizeForRowAt indexPath: IndexPath) -> ASSizeRange {
        let screenSize = Screen.bounds.width
        let minSize: CGSize = CGSize(width: screenSize, height: 60)
        let maxSize: CGSize = minSize
        return ASSizeRange(min: minSize, max: maxSize)
    }
}
